package test;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;

import lucee.loader.engine.CFMLEngine;
import lucee.loader.engine.CFMLEngineFactory;
import lucee.runtime.Component;
import lucee.runtime.PageContext;
import lucee.runtime.exp.PageException;

public class TestClass {

	public void start() throws Exception {
		
		CFMLEngine engine = CFMLEngineFactory.getInstance();
		PageContext pc = engine.getThreadPageContext();
		Component c = pc.loadComponent( "components.test" );
		Object result = c.call(pc,"test", new Object[]{"notInThread"});
		System.err.println("" + c + " => " + result);

		new Thread() {
			
			
			public void run() {
				
				try {
					CFMLEngine engine = CFMLEngineFactory.getInstance();
					
					Properties p = new Properties();
					File dir = new File(System.getProperty("java.io.tmpdir"));
					File properties = new File(dir,"test.properties");
					p.load(new FileInputStream(properties));
					System.err.println(properties.getAbsolutePath());
					
					String host = p.getProperty("host");
					String script = p.getProperty("script");
					File f = new File(p.getProperty("root"));
					String cfc = p.getProperty("cfc");
					
					System.err.println(f.getAbsolutePath());
					System.err.println(host);
					System.err.println(script);
					System.err.println(cfc);
					
					// cookies for this simulated request, can also be null
					javax.servlet.http.Cookie[] cookies = new Cookie[]{new Cookie("myCookie","myCookieValue")};
					// headers for this simulated request
					Map<String, Object> headers=new HashMap();
					headers.put("accept","text/html");
					// headers for this simulated request, can also be null
					Map<String, String> parameters=new HashMap();
					// headers for this simulated request, can also be null
					Map<String, Object> attributes=new HashMap();
					PageContext pc = engine.createPageContext(
							 f, host // host
							,script // script name
							,"no_auth=true" // query string
							,cookies
							,headers
							,parameters
							,attributes
							,System.err // response stream where the output is written to
							,50000 // timeout for the simulated request in milli seconds
							,true // register the pc to the thread
							);
					Component c = pc.loadComponent( cfc );
					Object result = c.call(pc,"test", new Object[]{"inThread"});
					System.err.println("" + c + " => " + result);
				} catch (Exception e) {
					e.printStackTrace();
				} 
			};
			
		}.start();
	}
	
}
